<?php

namespace App\Config;

// No eliminar este módulo, se utilizara para almacenar las notificaciones del sistema
$trash = [
    "nombre" => "Notificaciones",
    "descripcion" => "Módulos relacionados con las notificaciones del sistema",
    "icono" => "fas fa-bell",
    "hijos" => [
        [
            "nombre" => "Ver Notificaciones",
            "descripcion" => "Lista de notificaciones del sistema",
            "ruta" => "/notificaciones",
            "vista" => "modules/notificaciones/index.php",
            "icono" => "fa-solid fa-bell",
        ],
    ],
];

// Módulos del sistema ordenados por prioridad/importancia
return [
    // Core - Módulo principal
    [
        "nombre" => "Inicio",
        "descripcion" => "Página principal del sistema GTD",
        "icono" => "fas fa-home",
        "ruta" => "/home", // Ruta del módulo sin hijos
    ],

    // Gestión de tareas
    [
        "nombre" => "Tareas",
        "descripcion" => "Módulos relacionados con la gestión de tareas",
        "icono" => "fas fa-tasks",
        "hijos" => [
            [
                "nombre" => "Tablero Kanban",
                "descripcion" => "Tablero visual de tareas",
                "ruta" => "/tareas/kanban",
                "vista" => "modules/tareas/kanban.php",
                "icono" => "fa-solid fa-th-large",
            ],
        ],
    ],

    [
        "nombre" => "Fitness",
        "descripcion" => "Módulos relacionados con la salud y el bienestar físico",
        "icono" => "fas fa-dumbbell",
        "hijos" => [
            [
                "nombre" => "Rutinas de Ejercicio",
                "descripcion" => "Crear y gestionar rutinas de entrenamiento",
                "ruta" => "/fitness/rutinas",
                "vista" => "modules/fitness/rutinas.php",
                "icono" => "fa-solid fa-running",
            ],
            [
                "nombre" => "Recetas Saludables",
                "descripcion" => "Almacenar y visualizar recetas nutritivas",
                "ruta" => "/fitness/recetas",
                "vista" => "modules/fitness/recetas.php",
                "icono" => "fa-solid fa-utensils",
            ],
            [
                "nombre" => "Seguimiento de Actividades",
                "descripcion" => "Registrar y monitorear actividades físicas realizadas",
                "ruta" => "/fitness/seguimiento",
                "vista" => "modules/fitness/seguimiento.php",
                "icono" => "fa-solid fa-chart-line",
            ],
        ],
    ],

    [
        "nombre" => "Finanzas",
        "descripcion" => "Módulos para gestionar tus finanzas personales",
        "icono" => "fas fa-wallet",
        "hijos" => [
            [
                "nombre" => "Ingresos",
                "descripcion" => "Registrar y gestionar fuentes de ingresos",
                "ruta" => "/finanzas/ingresos",
                "vista" => "modules/finanzas/ingresos.php",
                "icono" => "fa-solid fa-plus-circle",
            ],
            [
                "nombre" => "Gastos",
                "descripcion" => "Registrar y categorizar gastos",
                "ruta" => "/finanzas/gastos",
                "vista" => "modules/finanzas/gastos.php",
                "icono" => "fa-solid fa-minus-circle",
            ],
            [
                "nombre" => "Presupuestos",
                "descripcion" => "Crear y monitorear presupuestos",
                "ruta" => "/finanzas/presupuestos",
                "vista" => "modules/finanzas/presupuestos.php",
                "icono" => "fa-solid fa-chart-pie",
            ],
            [
                "nombre" => "Reportes Financieros",
                "descripcion" => "Visualizar gráficos y reportes de finanzas personales",
                "ruta" => "/finanzas/reportes",
                "vista" => "modules/finanzas/reportes.php",
                "icono" => "fa-solid fa-chart-line",
            ],
        ],
    ],

    [
        "nombre" => "Eventos",
        "descripcion" => "Módulos para planificar y gestionar tus eventos importantes",
        "icono" => "fas fa-calendar-alt",
        "hijos" => [
            [
                "nombre" => "Crear Evento",
                "descripcion" => "Crear y programar nuevos eventos",
                "ruta" => "/eventos/crear",
                "vista" => "modules/eventos/crear.php",
                "icono" => "fa-solid fa-plus",
            ],
            [
                "nombre" => "Calendario de Eventos",
                "descripcion" => "Visualizar eventos en un calendario interactivo",
                "ruta" => "/eventos/calendario",
                "vista" => "modules/eventos/calendario.php",
                "icono" => "fa-solid fa-calendar",
            ],
            [
                "nombre" => "Recordatorios de Eventos",
                "descripcion" => "Configurar recordatorios para eventos próximos",
                "ruta" => "/eventos/recordatorios",
                "vista" => "modules/eventos/recordatorios.php",
                "icono" => "fa-solid fa-bell",
            ],
        ],
    ],


    // Configuración del sistema
    [
        "nombre" => "Configuración",
        "descripcion" =>
            "Módulos relacionados con la configuración del sistema",
        "icono" => "fas fa-cogs",
        "hijos" => [
            [
                "nombre" => "Preferencias",
                "descripcion" => "Gestión de configuraciones del sistema",
                "ruta" => "/configuracion",
                "vista" => "modules/configuracion/index.php",
                "icono" => "fa-solid fa-sliders-h",
            ],
            [
                "nombre" => "Plantillas de Correo",
                "descripcion" => "Crear y editar plantillas para diferentes tipos de correos",
                "ruta" => "/configuracion/correos/plantillas",
                "vista" => "modules/correos/plantillas.php",
                "icono" => "fa-solid fa-file-alt",
            ],
            [
                "nombre" => "Estados de Correo",
                "descripcion" => "Gestionar y visualizar los estados de los correos enviados",
                "ruta" => "/configuracion/correos/estados",
                "vista" => "modules/correos/estados.php",
                "icono" => "fa-solid fa-info-circle",
            ],
            [
                "nombre" => "Historial de Correos Enviados",
                "descripcion" => "Revisar el historial de correos enviados por el sistema",
                "ruta" => "/configuracion/correos/historial",
                "vista" => "modules/correos/historial.php",
                "icono" => "fa-solid fa-history",
            ],
        ],
    ],
];
