<?php

namespace App\Controllers;

use App\Entities\Exercise;
use App\Repositories\ExerciseRepository;
use App\Core\Database;
use App\Core\HttpHelper;
use App\Helpers\AuthHelper;

class ExerciseController extends BaseController
{
    protected ExerciseRepository $exerciseRepository;

    public function __construct()
    {
        $database = new Database();
        $this->exerciseRepository = new ExerciseRepository($database);
        parent::__construct($this->exerciseRepository);
    }

    public function showExercises()
    {
        $exercises = $this->exerciseRepository->getAll();
        $this->render('modules/fitness/exercises', ['exercises' => $exercises]);
    }
}
