<?php

namespace App\Entities;

class EmailStatus extends BaseEntity
{
    /**
     * @var int Identificador único del estado de correo.
     */
    public int $status_id;

    /**
     * @var string Nombre del estado de correo.
     */
    public string $status_name;

    /**
     * @var string|null Descripción del estado de correo.
     */
    public ?string $description;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "status_id";
    }
}
