<?php

namespace App\Entities;

class EmailTemplate extends BaseEntity
{
    /**
     * @var int Identificador único de la plantilla de correo.
     */
    public int $template_id;

    /**
     * @var string Nombre de la plantilla.
     */
    public string $template_name;

    /**
     * @var string Contenido HTML de la plantilla.
     */
    public string $html_content;

    /**
     * @var string Fecha de creación de la plantilla.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización de la plantilla.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "template_id";
    }
}
