<?php

namespace App\Entities;

use App\Entities\BaseEntity;

class Exercise extends BaseEntity
{
    /**
     * @var int Identificador único de Exercise.
     */
    public int $exercise_id;

    /**
     * @var string Nombre del ejercicio.
     */
    public string $name;

    /**
     * @var string tipo de ejercicio.
     */
    public string $type;

    /**
     * @var string musculo principal.
     */
    public string $muscle;

    /**
     * @var string Equipamiento necesario.
     */
    public string $equipment;

    /**
     * @var string Dificultad del ejercicio.
     */
    public string $difficulty;

    /**
     * @var string instrucciones del ejercicio.
     */
    public string $instructions;

    /**
     * @var string Fecha de creación de la tarea.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización de la tarea.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return 'exercise_id';
    }
}
