<?php

namespace App\Entities;

class Expense extends BaseEntity
{
    /**
     * @var int Identificador único del gasto.
     */
    public int $expense_id;

    /**
     * @var int Identificador del usuario asociado al gasto.
     */
    public int $user_id;

    /**
     * @var int Identificador de la categoría de gasto.
     */
    public int $category_id;

    /**
     * @var string Nombre del gasto.
     */
    public string $expense_name;

    /**
     * @var float Monto del gasto.
     */
    public float $amount;

    /**
     * @var int Identificador de la frecuencia del gasto.
     */
    public int $frequency_id;

    /**
     * @var string Fecha de creación del gasto.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización del gasto.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "expense_id";
    }
}
