<?php

namespace App\Entities;

class ExpenseCategory extends BaseEntity
{
    /**
     * @var int Identificador único de la categoría de gasto.
     */
    public int $category_id;

    /**
     * @var string Nombre de la categoría de gasto.
     */
    public string $category_name;

    /**
     * @var string|null Descripción de la categoría de gasto.
     */
    public ?string $description;

    /**
     * @var string Fecha de creación de la categoría.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización de la categoría.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "category_id";
    }
}
