<?php

namespace App\Entities;

class HealthyRecipe extends BaseEntity
{
    /**
     * @var int Identificador único de la receta.
     */
    public int $recipe_id;

    /**
     * @var int Identificador del usuario asociado a la receta.
     */
    public int $user_id;

    /**
     * @var string Nombre de la receta.
     */
    public string $recipe_name;

    /**
     * @var string|null Descripción de la receta.
     */
    public ?string $description;

    /**
     * @var array Lista de ingredientes de la receta.
     */
    public array $ingredients;

    /**
     * @var string Instrucciones para preparar la receta.
     */
    public string $instructions;

    /**
     * @var int Número de calorías de la receta.
     */
    public int $calories;

    /**
     * @var string Fecha de creación de la receta.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización de la receta.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "recipe_id";
    }
}
