<?php

namespace App\Entities;

class ImportantEvent extends BaseEntity
{
    /**
     * @var int Identificador único del evento importante.
     */
    public int $event_id;

    /**
     * @var int Identificador del usuario asociado al evento.
     */
    public int $user_id;

    /**
     * @var string Nombre del evento.
     */
    public string $event_name;

    /**
     * @var string Fecha del evento.
     */
    public string $event_date;

    /**
     * @var string|null Descripción del evento.
     */
    public ?string $description;

    /**
     * @var string Fecha de creación del evento.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización del evento.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "event_id";
    }
}
