<?php

namespace App\Entities;

class Income extends BaseEntity
{
    /**
     * @var int Identificador único del ingreso.
     */
    public int $income_id;

    /**
     * @var int Identificador del usuario asociado al ingreso.
     */
    public int $user_id;

    /**
     * @var string Nombre del ingreso.
     */
    public string $income_name;

    /**
     * @var float Monto del ingreso.
     */
    public float $amount;

    /**
     * @var int Identificador de la frecuencia del ingreso.
     */
    public int $frequency_id;

    /**
     * @var string Fecha de creación del ingreso.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización del ingreso.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "income_id";
    }
}
