<?php

namespace App\Entities;

class Notification extends BaseEntity
{
    /**
     * @var int Identificador único de la notificación.
     */
    public int $notification_id;

    /**
     * @var int Identificador del usuario asociado a la notificación.
     */
    public int $user_id;

    /**
     * @var int Identificador del tipo de notificación.
     */
    public int $type_id;

    /**
     * @var string Mensaje de la notificación.
     */
    public string $message;

    /**
     * @var bool Indica si la notificación ha sido leída.
     */
    public bool $is_read;

    /**
     * @var string Fecha de creación de la notificación.
     */
    public string $created_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "notification_id";
    }
}
