<?php

namespace App\Entities;

class SentEmail extends BaseEntity
{
    /**
     * @var int Identificador único del correo enviado.
     */
    public int $email_id;

    /**
     * @var int Identificador del usuario que envió el correo.
     */
    public int $user_id;

    /**
     * @var int Identificador de la plantilla del correo.
     */
    public int $template_id;

    /**
     * @var int Identificador del estado del correo.
     */
    public int $status_id;

    /**
     * @var string Asunto del correo.
     */
    public string $subject;

    /**
     * @var string Cuerpo del mensaje del correo.
     */
    public string $message;

    /**
     * @var string Fecha en la que se envió el correo.
     */
    public string $sent_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "email_id";
    }
}
