<?php

namespace App\Entities;

class Setting extends BaseEntity
{
    /**
     * @var int Identificador único de la configuración.
     */
    public int $setting_id;

    /**
     * @var string Clave de la configuración.
     */
    public string $setting_key;

    /**
     * @var string Valor de la configuración.
     */
    public string $setting_value;

    /**
     * @var string|null Descripción de la configuración.
     */
    public ?string $description;

    /**
     * @var string Fecha de creación de la configuración.
     */
    public string $created_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "setting_id";
    }
}
