<?php

namespace App\Entities;

class Task extends BaseEntity
{
    /**
     * @var int Identificador único de la tarea.
     */
    public int $task_id;

    /**
     * @var int Identificador del usuario que creó la tarea.
     */
    public int $user_id;

    /**
     * @var int Identificador del estado de la tarea.
     */
    public int $status_id;

    /**
     * @var string Título de la tarea.
     */
    public string $task_title;

    /**
     * @var string Color de la tarea.
     */
    public string $color;

    /**
     * @var string|null Descripción de la tarea.
     */
    public ?string $description;

    /**
     * @var string Fecha de vencimiento de la tarea.
     */
    public string $due_date;

    /**
     * @var string Fecha de creación de la tarea.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización de la tarea.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "task_id";
    }
}
