<?php

namespace App\Entities;

class User extends BaseEntity
{
    /**
     * @var int Identificador único del usuario.
     */
    public int $user_id;

    /**
     * @var string Nombre de usuario.
     */
    public string $username;

    /**
     * @var string Correo electrónico del usuario.
     */
    public string $email;

    /**
     * @var string Hash de la contraseña.
     */
    public string $password_hash;

    /**
     * @var string Fecha de creación.
     */
    public string $created_at;

    /**
     * @var string|null Fecha de última actualización.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "user_id";
    }
}
