<?php

namespace App\Entities;

class WorkoutRoutine extends BaseEntity
{
    /**
     * @var int Identificador único de la rutina.
     */
    public int $routine_id;

    /**
     * @var int Identificador del usuario asociado.
     */
    public int $user_id;

    /**
     * @var string Nombre de la rutina.
     */
    public string $routine_name;

    /**
     * @var string|null Descripción de la rutina.
     */
    public ?string $description;

    /**
     * @var string Tipo de rutina.
     */
    public string $routine_type;

    /**
     * @var array array de ejercicios asociados a la rutina.
     */
    public array $exercises;

    /**
     * @var int tiempo en minutos de la rutina.
     */
    public int $duration;

    /**
     * @var string fecha de creación de la rutina.
     */
    public string $created_at;

    /**
     * @var string|null fecha de última actualización de la rutina.
     */
    public ?string $updated_at;

    /**
     * Obtiene el nombre de la clave primaria de la entidad.
     *
     * @return string
     */
    public static function getPrimaryKey(): string
    {
        return "routine_id";
    }
}
