<?php

namespace App\Helpers;

use Firebase\JWT\JWT;
use Firebase\JWT\Key;

class AuthHelper
{
    public static function getUserIdFromToken(): ?int
    {
        $jwt = $_COOKIE["jwt"] ?? null;

        if (!$jwt) {
            return null;
        }

        try {
            $decoded = JWT::decode($jwt, new Key($_ENV["JWT_SECRET"], "HS256"));
            return $decoded->user_id ?? null;
        } catch (\Throwable $th) {
            return null;
        }
    }
}
