<!DOCTYPE html>
<html lang="es">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Iniciar Sesión</title>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link
        href="https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap"
        rel="stylesheet">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet">
    <style>
    /* Estilos comunes */
    body, html {
        height: 100%;
        font-family: 'Poppins', sans-serif;
        background-color: #f8f9fa;
        margin: 0;
    }

    .container {
        display: flex;
        justify-content: center;
        align-items: center;
        min-height: 100vh;
    }

    .card {
        border-radius: 10px;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
        padding: 2rem;
        background-color: #ffffff;
    }

    .form-control {
        border-radius: 8px;
    }

    .btn-primary {
        border-radius: 8px;
        transition: background-color 0.3s ease, transform 0.3s ease;
    }

    .btn-primary:hover {
        transform: scale(1.02);
    }

    .text-muted a {
        color: #007bff;
        text-decoration: none;
        transition: color 0.3s ease;
    }

    .text-muted a:hover {
        text-decoration: underline;
        color: #0056b3;
    }

    .text-center {
        text-align: center;
    }

    .fw-bold {
        font-weight: 600;
    }

    /* Ajustes para pantallas pequeñas */
    @media (max-width: 576px) {
        .card {
            padding: 1.5rem;
            border-radius: 8px;
        }

        .btn-primary {
            font-size: 0.95rem;
        }

        .text-muted a {
            font-size: 0.9rem;
        }
    }

    /* Ajustes para pantallas medianas */
    @media (min-width: 768px) and (max-width: 992px) {
        .card {
            padding: 2.5rem;
        }

        .btn-primary {
            font-size: 1rem;
        }

        .text-muted a {
            font-size: 1rem;
        }
    }

    /* Ajustes para pantallas grandes */
    @media (min-width: 992px) {
        .card {
            padding: 3rem;
        }

        .btn-primary {
            font-size: 1.1rem;
        }

        .text-muted a {
            font-size: 1rem;
        }
    }

    </style>
</head>

<body class="bg-light">
    <div class="container">
        <div class="col-md-6">
            <div class="card p-4">
                <h1 class="text-center fw-bold mb-2">GTD Assistant</h1>
                <p class="text-center mb-4">Dale un respiro a tu mente organizándote con este sistema.</p>
                <?php if (isset($error)): ?>
                    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>
                    <script>
                        Swal.fire({
                            icon: 'error',
                            title: 'Error',
                            text: '<?php echo htmlspecialchars(
                                $error,
                                ENT_QUOTES,
                                "UTF-8"
                            ); ?>',
                            confirmButtonColor: '#d33',
                            confirmButtonText: 'Aceptar'
                        });
                    </script>
                <?php endif; ?>
                <form action="/login" method="POST">
                    <div class="mb-3">
                        <label for="email" class="form-label">Correo Electrónico</label>
                        <input type="email" class="form-control" id="email" name="email" required>
                    </div>
                    <div class="mb-3">
                        <label for="password" class="form-label">Contraseña</label>
                        <input type="password" class="form-control" id="password" name="password" required>
                    </div>
                    <button type="submit" class="btn btn-primary w-100">Iniciar Sesión</button>
                </form>
                <p class="mt-3 text-center text-muted">¿No tienes una cuenta? <a href="/register">Regístrate</a></p>
            </div>
        </div>
    </div>
</body>

</html>
