#!/bin/bash

GREEN='\033[0;32m'
RED='\033[0;31m'
BLUE='\033[0;34m'
NC='\033[0m'

echo -e "${BLUE}=======================================${NC}"
echo -e "${BLUE}  Verificación de Extensiones de PHP   ${NC}"
echo -e "${BLUE}=======================================${NC}"

REQUIRED_EXTENSIONS=(
    "xdebug"
    "zip"
    "mbstring"
    "xml"
    "intl"
    "gmp"
    "sodium"
    "pdo_mysql"
)

echo -e "\nVerificando extensiones requeridas:\n"

ENABLED_COUNT=0
DISABLED_COUNT=0

for extension in "${REQUIRED_EXTENSIONS[@]}"; do
    if php -m | grep -q "$extension"; then
        echo -e "  ${GREEN}✔ $extension${NC}"
        ((ENABLED_COUNT++))
    else
        echo -e "  ${RED}✘ $extension${NC}"
        ((DISABLED_COUNT++))
    fi
done

echo -e "\n${BLUE}=======================================${NC}"
echo -e "${BLUE}             Resumen                   ${NC}"
echo -e "${BLUE}=======================================${NC}"
echo -e "  Extensiones habilitadas: ${GREEN}$ENABLED_COUNT${NC}"
echo -e "  Extensiones faltantes:   ${RED}$DISABLED_COUNT${NC}"
echo -e "${BLUE}=======================================${NC}"

if [ $DISABLED_COUNT -eq 0 ]; then
    echo -e "\n${GREEN}¡Todas las extensiones requeridas están habilitadas!${NC}"
else
    echo -e "\n${RED}Algunas extensiones requeridas no están habilitadas.${NC}"
    echo -e "Por favor, instale las extensiones faltantes."
fi

#php -m